{$A+,B-,D+,E+,F-,G+,I+,L+,N+,P+,Q-,R-,S-,T-,V+,X+,Y+}

{GUIUTILS
 --------
(C) 1999 by Arne von Wyss - avonwyss@beaulieu-software.ch

Rev: 19990802

Utility unit for GUI. This unit is the only part of the complete GUI package
(except for the external drivers) which has assembler and inline code, making
a GUI port easier.

This source code is freeware for non-commercial use and provided AS-IS.
You are not allowed to use or spread incomplete (inclusive this header)
copies of this code. Use at your own risk. If you do not agree with these
statements, delete this source code immediately. Please contact the
author via email for questions or bug reports.}

unit GUIUtils;

interface

procedure Swap(var X,Y; Cnt: Word);
procedure MoveW(var Src,Dst; Count: Word);
procedure MoveL(var Src,Dst; Count: Word);
function DriveValid(Drive: Char): Boolean;
{procedure Convert8ToRGB(Count: Integer; const Src; var Dst; RGB: Word);
procedure ConvertRGBTo8(Count: Integer; const Src; RGB: Word; var Dst);
procedure Convert1ToRGB(Count: Integer; const Src; var Dst; RGB: Word);
procedure ConvertRGBTo1(Count: Integer; const Src; RGB: Word; var Dst);
procedure Convert1To8(Count: Integer; const Src; var Dst);
procedure Convert8To1(Count: Integer; const Src; var Dst);
procedure ConvertRGBToRGB(Count: Integer; const Src; SRGB: Word; var Dst; DRGB: Word);}
function Maximum(X,Y: Integer): Integer;
inline($58/         {pop ax}
		 $5B/           {pop bx}
		 $39/$D8/       {cmp ax,bx}
		 $7D/$02/       {jle  $+4}
		 $89/$D8);      {mov ax,bx}
function Minimum(X,Y: Integer): Integer;
inline($58/         {pop ax}
		 $5B/           {pop bx}
		 $39/$D8/       {cmp ax,bx}
		 $7E/$02/       {jge  $+4}
		 $89/$D8);      {mov ax,bx}
function Sign(I: Integer): Integer;
inline($58/         {pop ax}
		 $0B/$C0/       {or  ax,ax}
		 $74/$06/       {jz  $+8}
		 $C1/$F8/$0F/   {sar ax,$F}
		 $0D/$01/$00);  {or  ax,1}
procedure Void(P: Pointer);
inline($83/$C4/$04);{add sp,4}

implementation

procedure Swap(var X,Y; Cnt: Word); assembler;
asm
			mov dx,ds
			mov cx,[cnt]
			mov bx,cx
			les di,[x]
			lds si,[y]
			cld
			shr cx,2
			jz @bytes
@loop:
 db $66; mov ax,es:[di]  {mov eax,es:[di]}
 db $66; xchg ds:[si],ax {xchg ds:[si],eax}
 db $66; stosw           {stosd}
			add si,4
			loop @loop
@bytes:
			and bx,3
			jz @endasm
			mov cx,bx
@loop2:
			mov al,es:[di]
			xchg ds:[si],al
			stosb
			inc si
			loop @loop2
@endasm: mov ds,dx
end;

procedure MoveW(var Src,Dst; Count: Word); assembler;
asm
			mov	cx,[count]
			jcxz	@endasm
			mov	bx,ds
			les	di,[dst]
			lds	si,[src]
			cld
			mov	ax,es
			mov	dx,ds
			cmp	ax,dx
			jne	@copy
			cmp	si,di
			jae	@copy
			mov	dx,cx
			dec	dx
			add	dx,dx
			add	si,dx
			add	di,dx
			std
@copy:	rep	movsw
			mov	ds,bx
@endasm:
end;

procedure MoveL(var Src,Dst; Count: Word); assembler;
asm
			mov	cx,[count]
			jcxz	@endasm
			mov	bx,ds
			les	di,[dst]
			lds	si,[src]
			cld
			mov	ax,es
			mov	dx,ds
			cmp	ax,dx
			jne	@copy
			cmp	si,di
			jae	@copy
			mov	dx,cx
			dec	dx
			shl	dx,2
			add	si,dx
			add	di,dx
			std
@copy:
 db $66;	rep	movsw
			mov	ds,bx
@endasm:
end;

function DriveValid(Drive: Char): Boolean; assembler;
asm
			MOV	AH,19H    { Save the current drive in BL }
			INT	21H
			MOV	BL,AL
			MOV	DL,Drive	{ Select the given drive }
			SUB	DL,'A'
			MOV	AH,0EH
			INT	21H
			MOV	AH,19H		{ Retrieve what DOS thinks is current }
			INT	21H
			MOV	CX,0		  { Assume false }
			CMP	AL,DL		  { Is the current drive the given drive? }
			JNE	@@1
			MOV	CX,1		  { It is, so the drive is valid }
			MOV	DL,BL		  { Restore the old drive }
			MOV	AH,0EH
			INT	21H
@@1:	XCHG	AX,CX		{ Put the return value into AX }
end;

end.