unit WildCard;

interface

function PosX(const SubStr,S: string; Start: Integer): Integer;
function Match(S,Mask: string; IgnoreCase: Boolean): Boolean;

implementation

function PosX(const SubStr,S: string; Start: Integer): Integer;
var
	I,J,Len: Integer;
begin
	Len:=Length(SubStr);
	if Len=0 then begin
		PosX:=1;
		Exit;
	end;
	for I:=Start to Succ(Length(S)-Len) do begin
		J:=1;
		while J<=Len do begin
			if not ((SubStr[J]='?') or (SubStr[J]=S[Pred(I+J)])) then
				Break;
			Inc(J);
		end;
		if J>Len then begin
			PosX:=I;
			Exit;
		end;
	end;
	PosX:=0;
end;

function Match(S,Mask: string; IgnoreCase: Boolean): Boolean;
const
	WildSize=0; {minimal number of characters representing a "*"}
var
	Min,Max,At,MaskSTart,MaskEnd: Integer;
	T: string;
begin
	if IgnoreCase then begin
		for At:=1 to Length(S) do
			S[At]:=UpCase(S[At]);
		for At:=1 to Length(Mask) do
			Mask[At]:=UpCase(Mask[At]);
	end;
	S:=S+#0;
	Mask:=Mask+#0;
	Min:=1;
	Max:=1;
	MaskEnd:=0;
	while Length(Mask)>=MaskEnd do begin
		MaskStart:=MaskEnd+1;
		repeat
			Inc(MaskEnd);
		until (MaskEnd>Length(Mask)) or (Mask[MaskEnd]='*');
		T:=Copy(Mask,MaskStart,MaskEnd-MaskStart);
		At:=PosX(T,S,Min);
		if (At=0) or (At>Max) then begin
			Match:=False;
			Exit;
		end;
		Min:=At+Length(T)+WildSize;
		Max:=Length(S);
	end;
	Match:=True;
end;

end.